--- a/read.c
+++ b/read.c
@@ -1,5 +1,7 @@
 #include <X11/Xlib.h>
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
 #include "compact.h"
 #include "medcut.h"
 
--- a/medcut.c
+++ b/medcut.c
@@ -1,4 +1,5 @@
 #include <stdio.h>
+#include <stdlib.h>
 #include "medcut.h"
 
 #define RED     0
--- a/xfish.c
+++ b/xfish.c
@@ -46,6 +46,9 @@
 #endif
 
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
 #ifdef sgi
 #define _BSD_SIGNALS
 #endif
@@ -848,8 +850,8 @@
 	struct colr_data colrs[256];
 
 	colormap = XDefaultColormap(Dpy, screen);

-	if (colormap == NULL)
+	if (colormap == 0)
 	{
 		return;
 	}
@@ -1812,9 +1814,11 @@
 high_res_sleep(seconds)
     double      seconds;
 {
-    int         fds = 0;
+    fd_set      fds;
     struct timeval timeout;
 
+    FD_ZERO(&fds);
+
     timeout.tv_sec = seconds;
     timeout.tv_usec = (seconds - timeout.tv_sec) * 1000000.0;
     select(0, &fds, &fds, &fds, &timeout);
--- a/makeh.c
+++ b/makeh.c
@@ -1,6 +1,6 @@
-
+#include <stdlib.h>
 #include <stdio.h>
-
+#include <string.h>
 main()
 {
 	FILE *fp;
--- a/gifread.c
+++ b/gifread.c
@@ -56,6 +56,8 @@
 
 #include <X11/Xlib.h>
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
 #if  defined(SYSV) || defined(SVR4)
 #include <string.h>
 #else	/* SYSV */
